//===------------------------------------------------------------*- C++ -*-===//
//
// T-EMU: The Terma Emulator
// (c) Terma 2015
// Authors: Mattias Holm <maho (at) terma.com>
//
//===----------------------------------------------------------------------===//

#ifndef TEMU_MACHINE_H
#define TEMU_MACHINE_H

#include "temu-c/Support/Cpu.h"
#include "temu-c/Support/Objsys.h"
#include "temu-c/Target/Cpu.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Standard machine interface
 */
typedef struct temu_MachineIface {
  void (*reset)(void *Obj, int ResetType);
  temu_CpuExitReason (*run)(void *Obj, uint64_t NanoSecs);
  temu_CpuExitReason (*step)(void *Obj, int CpuId, uint64_t Steps);
  temu_CpuIfaceRef (*getCurrentCpu)(void *Obj);
  temu_CpuIfaceRef (*getCpu)(void *Obj, unsigned Idx);
  int64_t (*getTime)(void *Machine);
} temu_MachineIface;

TEMU_IFACE_REFERENCE_TYPE(temu_Machine);

#ifdef __cplusplus
}
#endif

#endif /* ! TEMU_DEVICE_H */
